import discord
from discord.ext import commands


class Developer(commands.Cog):
	"""This class is intended only for the developer, mainly for testing purposes"""

	def __init__(self, bot):
		self.bot = bot

	@commands.Cog.listener()
	async def on_ready(self):
		await self.bot.change_presence(status=discord.Status.online, activity=discord.Game('One Night Ultimate Werewolf'))
		print('We have logged in as {0.user}'.format(self.bot))

	@commands.command()
	async def hello(self, ctx):
		await ctx.send(f"Hello {ctx.message.author.name} :wave:")

	@commands.command()
	async def ping(self, ctx):
		print("pong", self.bot.owner_id, await self.bot.application_info())
		print(await self.bot.is_owner(ctx.author))
		await ctx.send("pong")

	async def is_dev(ctx):
		if ctx.author.id == 461892912821698562:
			return True
		await ctx.send("This command is not for you!")
		return False

	@commands.command()
	@commands.check(is_dev)
	async def logout(self, ctx):
		await self.bot.logout()

	@commands.command()
	@commands.check(is_dev)
	async def debug(self, ctx, *args):
		embed = discord.Embed(title=f"Village won!", color=0x00ffff)
		won_emoji = ":trophy:"
		dead_emoji = ":test:"
		tab = "\t"
		space = "<:space:705863033871663185>"
		embed.add_field(name=str("Name"), value=f"{won_emoji}{space}{dead_emoji}{space}{space}{3}:ballot_box:{tab}role: werewolf{tab}(was: drunk){tab}:point_right: someone", inline=False)
		await ctx.send(embed=embed)
		await ctx.send(":test::skull:")

		for emoji in ctx.guild.emojis:
			await ctx.send(emoji)
			print(emoji.id)

	@debug.error
	async def debug_error(self, ctx, error):
		await ctx.send(error)


def setup(bot):
	bot.add_cog(Developer(bot))
