# discord imports
from discord.ext import commands

# local imports
from ..game_cog import Game_cog
from .game import Werewolf_game


class Werewolf_cog(Game_cog):
	"""This singleton class is a Discord Cog for the interaction in the werewolf game"""

	@commands.group(invoke_without_command=True)
	async def werewolf(self, ctx):
		# TODO: isn't there a better way to have a default subcommand?
		await ctx.invoke(self.bot.get_command('werewolf info'))

	@werewolf.command()
	async def info(self, ctx):
		"""Send information about the subcommands for the game"""
		await super().info(ctx, Werewolf_game)

	@werewolf.command()
	async def setup(self, ctx):
		"""This function creates an game instance for this channel"""
		await super().setup(ctx, Werewolf_game)

	@werewolf.command()
	async def reset(self, ctx):
		"""This function deletes the game instance for this channel"""
		await super().reset(ctx)


def setup(bot):
	bot.add_cog(Werewolf_cog(bot, None))
