"""
This is the main module of the Discord Bot

Mainly loads the Cog's and starts the bot
"""

__version__ = '0.3'
__author__ = 'Bibin Muttappillil'

# standard library imports
import os
from dotenv import load_dotenv

# discord imports
from discord.ext import commands


# Token stuff
load_dotenv()
TOKEN = os.getenv('DISCORD_TOKEN')
if TOKEN is None:
	print("Missing discord token!")
	exit(1)

bot = commands.Bot(command_prefix=commands.when_mentioned_or('$w '))

bot.load_extension('package.developer')
bot.load_extension('package.games.werewolf.cog')


@bot.command()
@commands.is_owner()
async def reload(ctx, extension):
	bot.reload_extension(f'{extension}')


# checker annotations
# TODO: replace with discord.py error handling?

'''
def error_handling(command):
	@functools.wraps(command)
	async def wrapper(ctx, *args, **kwargs):
		try:
			await command(ctx, *args, **kwargs)
		except ValueError as error:
			await send_wrong(ctx, str(error))
		except asyncio.TimeoutError:
			await send_wrong(ctx, "Error: I got bored waiting for your input")
	return wrapper
'''

'''

# TODO: (specifig game) werewolf COG

@game.command()
@game_not_running
@error_handling
async def roles(ctx, *args):
	await game_instances[ctx.channel].set_roles(args)


@game.command()
@game_not_running
@error_handling
async def minutes(ctx, i):
	await game_instances[ctx.channel].set_time(i)


@game.command()
@game_running
@error_handling
async def time(ctx):
	await send_friendly(ctx, game_instances[ctx.channel].remaining_time_string())
'''

bot.run(TOKEN)
